<?php

// Bootstrap file for getting the ABSPATH constant to wp-load.php
require_once('../../config.php');

// check for rights
if ( !is_user_logged_in() || !current_user_can('edit_posts') ) 
	wp_die(__("You are not allowed to be here"));
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Insert Sales Buttons</title>
<script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/1.6.1/jquery.js"></script>
<script language="javascript" type="text/javascript" src="<?php echo home_url(); ?>/wp-includes/js/tinymce/tiny_mce_popup.js"></script>
<style type="text/css" src="<?php echo home_url(); ?>/wp-includes/js/tinymce/themes/advanced/skins/wp_theme/dialog.css"></style>
<link rel="stylesheet" type="text/css" href="<?php echo home_url(); ?>/wp-content/plugins/wp-graphix-magic-light/includes/salesbuttons/salesbuttons-tinymce.css" />

<script type="text/javascript">
 var ButtonDialog = {
	local_ed : 'ed',
	init : function(ed) {
		ButtonDialog.local_ed = ed;
		tinyMCEPopup.resizeToInnerSize();
	},
	insert : function insertButton(ed) {
 
		// set up variables to contain our input values
		var image = jQuery('#sbuttons-dialog input:radio:checked').val();
		var align = jQuery('select#sbutton-align').val();
		var link = jQuery('#sbuttons-dialog input#sbutton-link').val();
		var alt = jQuery('#sbuttons-dialog input#sbutton-alt').val();
		var new_window = jQuery('#sbuttons-dialog select#sbutton-target').val();
 
		var output = '';
 
		// setup the output of our shortcode
		output = '[wpgfxm_salesbuttons ';
			output += 'image="' + image + '" ';
			output += 'align="' + align + '" ';
			output += 'new_window="' + new_window + '" ';
			output += 'alt="' + alt + '" ';

		// only insert if the link field is not blank
		if(link) {
			output += 'link="' + link;
		}
		// if it is blank
		else {
			output += 'link="' + "#";
		}
			output += '"]';
 
		tinyMCEPopup.execCommand('mceInsertContent', false, output);
 
		// Return
		tinyMCEPopup.close();
	}
};
tinyMCEPopup.onInit.add(ButtonDialog.init, ButtonDialog);
</script>

</head>

<body>
	<div id="sbuttons-dialog">
		<form action="/" method="get" accept-charset="utf-8">
			<div id="sbuttons-note">
			<p>Choose Your Sales Button</p>
			</div>
				<div id="sbuttons-container">
					<div id="sbutton-row">
						<div class="sbutton-box">
							<?php echo '<img src="' .plugins_url('salesbuttons/salesbutton-images/o-add-to-cart.png', dirname(__FILE__)). '" width="190" height="65" border="0" /> '; ?>
							<p>Approximate Size: 378px by 125px</p>
							<input type="radio" name="sbutton-image" value="o-add-to-cart" id="sbutton-image" />
						</div>
						<div class="sbutton-box">
							<?php echo '<img src="' .plugins_url('salesbuttons/salesbutton-images/o-buy-now.png', dirname(__FILE__)). '" width="190" height="65" border="0" /> '; ?>
							<p>Approximate Size: 378px by 125px</p>
							<input type="radio" name="sbutton-image" value="o-buy-now" id="sbutton-image" />
						</div>
						<div class="sbutton-box">
							<?php echo '<img src="' .plugins_url('salesbuttons/salesbutton-images/o-download-now.png', dirname(__FILE__)). '" width="190" height="65" border="0" /> '; ?>
							<p>Approximate Size: 378px by 125px</p>
							<input type="radio" name="sbutton-image" value="o-download-now" id="sbutton-image" />
						</div>
						<div class="sbutton-alignment">
							<label for="sbutton-align">Button Align</label>
							<select name="sbutton-align" id="sbutton-align">
								<option value="left">Left</option>
								<option value="right">Right</option>
								<option value="center">Center</option>
							</select>
						</div>
						<div class="sbutton-link">
							<label for="sbutton-link">Button Link</label>
							<input type="text" name="sbutton-link" value="" id="sbutton-link" />
							<span style="color:#ce3402;font-size:10px;text-align:center;"><i>Please include http://</i></span>
						</div>
						<div class="sbutton-alt">
							<label for="sbutton-alt">Alt Title</label>
							<input type="text" name="sbutton-alt" value="" id="sbutton-alt" />
						</div>
						<div class="sbutton-window">
							<label for="sbutton-target">Open in New Window?</label>
							<select name="sbutton-target" id="sbutton-target">
								<option value="_self" selected="selected">No (default)</option>
								<option value="_blank">Yes</option>
							</select>
						</div>
						<div class="get-full">
							<p><strong>You are using the FREE version of WP Graphix Magic!</strong> To get the <strong>FULL version</strong> which contains dozens more graphics, options, and shortcodes... Grab your copy at <a href="http://www.wpgraphixmagic.com" title="WP Graphix Magic" target="_blank">www.wpgraphixmagic.com</a>!</p>
						</div>
					</div><!-- End badge-row -->
				</div><!-- End container -->
			<div>	
				<a href="javascript:ButtonDialog.insert(ButtonDialog.local_ed)" id="insert" style="display:block; line-height:24px;">Insert</a>
			</div>
		</form>
	</div><!-- End salesbuttons-dialog -->
</body>
</html>