<?php

//Enable WooSEO on these custom Post types
$seo_post_types = array('post','page');
define("SEOPOSTTYPES", serialize($seo_post_types));

//Global options setup
add_action('init','woo_global_options');
function woo_global_options(){
	// Populate WooThemes option in array for use in theme
	global $woo_options;
	$woo_options = get_option('woo_options');
}

add_action('admin_head','woo_options');  
if (!function_exists('woo_options')) {
function woo_options(){
// VARIABLES
$themename = "Headlines Enhanced";
$manualurl = 'http://www.woothemes.com/support/theme-documentation/headlines';
$shortname = "woo";



$GLOBALS['template_path'] = get_bloginfo('template_directory');

//Access the WordPress Categories via an Array
$woo_categories = array();  
$woo_categories_obj = get_categories('hide_empty=0');
foreach ($woo_categories_obj as $woo_cat) {
    $woo_categories[$woo_cat->cat_ID] = $woo_cat->cat_name;}
$categories_tmp = array_unshift($woo_categories, "Select a category:");    
       
//Access the WordPress Pages via an Array
$woo_pages = array();
$woo_pages_obj = get_pages('sort_column=post_parent,menu_order');    
foreach ($woo_pages_obj as $woo_page) {
    $woo_pages[$woo_page->ID] = $woo_page->post_name; }
$woo_pages_tmp = array_unshift($woo_pages, "Select a page:");       


//Testing 
$options_select = array("one","two","three","four","five"); 
$options_radio = array("alignleft" => "Left","alignright" => "Right","aligncenter" => "Center");
$options_noheadfoot_bstyle = array("solid" => "Solid","dashed" => "Dashed","dotted" => "Dotted");
$options_left_ribbon_stars = array("5-stars" => "5 Stars","4-stars" => "4 Stars","3-stars" => "3 Stars","2-stars" => "2 Stars","1-star" => "1 Star");
$options_center_ribbon_stars = array("5-stars" => "5 Stars","4-stars" => "4 Stars","3-stars" => "3 Stars","2-stars" => "2 Stars","1-star" => "1 Star");
$options_right_ribbon_stars = array("5-stars" => "5 Stars","4-stars" => "4 Stars","3-stars" => "3 Stars","2-stars" => "2 Stars","1-star" => "1 Star");

//Stylesheets Reader
$alt_stylesheet_path = TEMPLATEPATH . '/styles/';
$alt_stylesheets = array();

if ( is_dir($alt_stylesheet_path) ) {
    if ($alt_stylesheet_dir = opendir($alt_stylesheet_path) ) { 
        while ( ($alt_stylesheet_file = readdir($alt_stylesheet_dir)) !== false ) {
            if(stristr($alt_stylesheet_file, ".css") !== false) {
                $alt_stylesheets[] = $alt_stylesheet_file;
            }
        }    
    }
}

//More Options


$other_entries = array("Select a number:","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19");

// THIS IS THE DIFFERENT FIELDS
$options = array();   

$options[] = array( "name" => "General Settings",
                    "icon" => "general",
                    "type" => "heading");

$options[] = array( "name" => "Theme Stylesheet",
					"desc" => "Select your themes alternative color scheme.",
					"id" => $shortname."_alt_stylesheet",
					"std" => "default.css",
					"type" => "select",
					"options" => $alt_stylesheets);
                        
$options[] = array( "name" => "Custom Logo",
					"desc" => "Upload a logo for your theme, or specify an image URL directly.",
					"id" => $shortname."_logo",
					"std" => "",
					"type" => "upload");    

$options[] = array( "name" => "Text Title",
					"desc" => "Enable text-based Site Title and Tagline. Setup title & tagline in Settings->General.",
					"id" => $shortname."_texttitle",
					"std" => "false",
					"class" => "collapsed",
					"type" => "checkbox");

$options[] = array( "name" => "Site Title",
					"desc" => "Change the site title (must have 'Text Title' option enabled).",
					"id" => $shortname."_font_site_title",
					"std" => array('size' => '36','unit' => 'px','face' => 'Arial','style' => 'bold','color' => '#ffffff'),
					"class" => "hidden",
					"type" => "typography");  

$options[] = array( "name" => "Site Description",
					"desc" => "Change the site description (must have 'Text Title' option enabled).",
					"id" => $shortname."_font_tagline",
					"std" => array('size' => '11','unit' => 'px','face' => 'Arial','style' => '','color' => '#bbbbbb'),
					"class" => "hidden last",
					"type" => "typography");  
                                                                                     
$options[] = array( "name" => "Custom Favicon",
					"desc" => "Upload a 16px x 16px <a href='http://www.faviconr.com/'>ico image</a> that will represent your website's favicon.",
					"id" => $shortname."_custom_favicon",
					"std" => "",
					"type" => "upload"); 
                                               
$options[] = array( "name" => "Tracking Code",
					"desc" => "Paste your Google Analytics (or other) tracking code here. This will be added into the footer template of your theme.",
					"id" => $shortname."_google_analytics",
					"std" => "",
					"type" => "textarea");        

$options[] = array( "name" => "RSS URL",
					"desc" => "Enter your preferred RSS URL. (Feedburner or other)",
					"id" => $shortname."_feedburner_url",
					"std" => "",
					"type" => "text");
                    
$options[] = array( "name" => "E-Mail URL",
					"desc" => "Enter your preferred E-mail subscription URL. (Feedburner or other)",
					"id" => $shortname."_feedburner_id",
					"std" => "",
					"type" => "text");

$options[] = array( "name" => "Contact Form E-Mail",
					"desc" => "Enter your E-mail address to use on the Contact Form Page Template.",
					"id" => $shortname."_contactform_email",
					"std" => "",
					"type" => "text");

$options[] = array( "name" => "Custom CSS",
                    "desc" => "Quickly add some CSS to your theme by adding it to this block.",
                    "id" => $shortname."_custom_css",
                    "std" => "",
                    "type" => "textarea");
                    
$options[] = array( "name" => "Styling Options",
					"type" => "heading",
					"icon" => "styling");   
                    

$options[] = array( "name" =>  "Custom Link Color",
					"desc" => "Add a custom hex color for the links in your site e.g. #697e09",
					"id" => "woo_custom_link",
					"std" => "",
					"type" => "color");

$options[] = array( "name" =>  "Custom Background Color",
					"desc" => "Add a custom hex color for the background e.g. #697e09",
					"id" => "woo_custom_bg",
					"std" => "",
					"type" => "color");
    
$options[] = array( "name" => "Navigation Options",
                    "icon" => "nav",
					"type" => "heading");

$options[] = array( "name" => "Exclude Pages In Top Navigation Bar",
					"desc" => "Comma separate Page IDs, e.g. 18,19",
					"id" => $shortname."_page_nav_disable",
					"std" => "",
					"type" => "text");

$options[] = array( "name" => "Disable Search Field",
					"desc" => "Remove the Search Field in the right side of nav, to make room for more categories.",
					"id" => $shortname."_search_disable",
					"std" => "false",
					"type" => "checkbox");

$options[] = array( "name" => "Disable Date &amp; Comments Count (by line) On Posts",
					"desc" => "Remove the Date and Comments from just below the post title.",
					"id" => $shortname."_disable_posts_date",
					"std" => "false",
					"type" => "checkbox"); 

$options[] = array( "name" => "Disable Date &amp; Comments Count (by line) On Categories",
					"desc" => "Remove the Date and Comments from just below the post title.",
					"id" => $shortname."_disable_cats_date",
					"std" => "false",
					"type" => "checkbox");

$options[] = array( "name" => "Disable Date &amp; Comments Count (by line) On The Search Result Page",
					"desc" => "Remove the Date and Comments from just below the post title.",
					"id" => $shortname."_disable_search_date",
					"std" => "false",
					"type" => "checkbox");

$options[] = array( "name" => "Disable Date &amp; Time On Comments",
					"desc" => "Remove Date and Time from on comments.",
					"id" => $shortname."_disable_comments_date",
					"std" => "false",
					"type" => "checkbox");

$options[] = array( "name" => "Show Page Navigation At The Bottom Of The Homepage",
					"desc" => "You must have more posts than what shows on Settings >> Reading",
					"id" => $shortname."_show_number_results",
					"std" => "false",
					"type" => "checkbox"); 

$options[] = array( "name" => "Homepage Options",
                    "icon" => "featured",
					"type" => "heading");    

$options[] = array( "name" => "Enable Slider On Homepage",
					"desc" => "Show the slider on the homepage page.",
					"id" => $shortname."_featured_slider",
					"std" => "true",
					"class" => "collapsed",
					"type" => "checkbox");

$options[] = array( "name" => "Slideshow Homepage Shortcode",
					"desc" => "By default, this will display the first Slideshow shortcode created!",
					"id" => $shortname."_featured_shortcode",
					"type" => "text",
					"class" => "hidden last",
					"std" => "[pb_slideshow group=\"0\"]");

$options[] = array( "name" => "Enable Video On Homepage <u>Instead Of</u> Slider",
					"desc" => "Show video, e.g. YouTube, on the homepage page.",
					"id" => $shortname."_featured_video",
					"std" => "false",
					"class" => "collapsed",
					"type" => "checkbox");

$options[] = array( "name" => "Video Embed Code - <i>Video Size Should Be 580px by 300px</i>",
					"desc" => "Please note the ideal size of video should be 580px by 300px!",
					"id" => $shortname."_featured_video_embed_code",
					"type" => "textarea",
					"class" => "hidden last",
					"std" => 'Paste Your Video Code Here. Size of video must be 580px by 300px!');

$options[] = array( "name" => "Display Sticky Posts <u>Only</u> On The Homepage?",
					"desc" => "Show only sticky posts on homepage",
					"id" => $shortname."_sticky_posts_only",
					"std" => "true",
					"type" => "checkbox");   

$options[] = array( "name" => "Number of Sticky Posts (Only) On Homepage",
					"desc" => "Enter number of sticky posts to show",
					"id" => $shortname."_sticky_posts_count",
					"type" => 'text',
					"std" => "5");

$options[] = array( "name" => "Homepage Top Sidebar",
                    "icon" => "topsidebar",
					"type" => "heading");

$options[] = array( "name" => "Display 3 Widgets On Homepage?",
					"desc" => "Show 3 widgets below header &amp; above posts/sidebar",
					"id" => $shortname."_top_widgets",
					"std" => "false",
					"type" => "checkbox");

$options[] = array( "name" => "Show On All Posts?",
					"desc" => "Tick the box if you want to show the top sidebar on all Posts",
					"id" => $shortname."_top_widgets_allposts",
					"std" => "false",
					"type" => "checkbox");

$options[] = array( "name" => "Show Top Sidebar By Post IDs Only <span style='color:#e82f0b;font-size:12px;'>(Untick Box Above!)</span>",
					"desc" => "Enter the Post IDs to show the top sidebar",
					"id" => $shortname."_top_widgets_bypost_ids",
					"std" => "",
					"type" => "text");

$options[] = array( "name" => "Show on All Pages?",
					"desc" => "Tick the box if you want to show the top sidebar on all Pages",
					"id" => $shortname."_top_widgets_allpages",
					"std" => "false",
					"type" => "checkbox");

$options[] = array( "name" => "Show Top Sidebar By Page IDs Only <span style='color:#e82f0b;font-size:12px;'>(Untick Box Above!)</span>",
					"desc" => "Enter the Page IDs to show the top sidebar",
					"id" => $shortname."_top_widgets_bypage_ids",
					"std" => "",
					"type" => "text");

$options[] = array( "name" =>  "Custom Left Ribbon Color",
					"desc" => "Add a custom hex color for the left ribbon color e.g. #697e09",
					"id" => $shortname."_custom_l_ribbon_color",
					"std" => "",
					"type" => "color");

$options[] = array( "name" =>  "Custom Left Ribbon Font Color",
					"desc" => "Add a custom hex color for the left ribbon font color e.g. #697e09",
					"id" => $shortname."_custom_l_ribbon_font_color",
					"std" => "",
					"type" => "color");

$options[] = array( "name" =>  "Custom Left Ribbon Border Color",
					"desc" => "Add a custom hex color for the left ribbon border color e.g. #697e09",
					"id" => $shortname."_custom_l_ribbon_border_color",
					"std" => "",
					"type" => "color");

$options[] = array( "name" => "Add Star Rating To Left Ribbon?",
					"desc" => "Tick the box if you want to show a star rating on the left ribbon",
					"id" => $shortname."_add_l_star_image",
					"std" => "true",
					"type" => "checkbox");

$options[] = array( "name" => "Select Number Of Stars",
					"desc" => "Select star type",
					"id" => $shortname."_stars_left_ribbon",
					"std" => "solid",
					"type" => "radio",
					"options" => $options_left_ribbon_stars);

$options[] = array( "name" =>  "Custom Center Ribbon Color",
					"desc" => "Add a custom hex color for the center ribbon color e.g. #697e09",
					"id" => $shortname."_custom_c_ribbon_color",
					"std" => "",
					"type" => "color");

$options[] = array( "name" =>  "Custom Center Ribbon Font Color",
					"desc" => "Add a custom hex color for the left ribbon font color e.g. #697e09",
					"id" => $shortname."_custom_c_ribbon_font_color",
					"std" => "",
					"type" => "color");

$options[] = array( "name" =>  "Custom Center Ribbon Border Color",
					"desc" => "Add a custom hex color for the center ribbon border color e.g. #697e09",
					"id" => $shortname."_custom_c_ribbon_border_color",
					"std" => "",
					"type" => "color");

$options[] = array( "name" => "Add Star Rating To Center Ribbon?",
					"desc" => "Tick the box if you want to show a star rating on the center ribbon",
					"id" => $shortname."_add_c_star_image",
					"std" => "true",
					"type" => "checkbox");

$options[] = array( "name" => "Select Number Of Stars",
					"desc" => "Select star type",
					"id" => $shortname."_stars_center_ribbon",
					"std" => "solid",
					"type" => "radio",
					"options" => $options_center_ribbon_stars);

$options[] = array( "name" =>  "Custom Right Ribbon Color",
					"desc" => "Add a custom hex color for the right ribbon color e.g. #697e09",
					"id" => $shortname."_custom_r_ribbon_color",
					"std" => "",
					"type" => "color");

$options[] = array( "name" =>  "Custom Right Ribbon Font Color",
					"desc" => "Add a custom hex color for the right ribbon font color e.g. #697e09",
					"id" => $shortname."_custom_r_ribbon_font_color",
					"std" => "",
					"type" => "color");

$options[] = array( "name" =>  "Custom Right Ribbon Border Color",
					"desc" => "Add a custom hex color for the right ribbon border color e.g. #697e09",
					"id" => $shortname."_custom_r_ribbon_border_color",
					"std" => "",
					"type" => "color");

$options[] = array( "name" => "Add Star Rating To Right Ribbon?",
					"desc" => "Tick the box if you want to show a star rating on the right ribbon",
					"id" => $shortname."_add_r_star_image",
					"std" => "true",
					"type" => "checkbox");

$options[] = array( "name" => "Select Number Of Stars",
					"desc" => "Select star type",
					"id" => $shortname."_stars_right_ribbon",
					"std" => "solid",
					"type" => "radio",
					"options" => $options_right_ribbon_stars);    

$options[] = array( "name" => "Layout Options",
                    "icon" => "layout",
					"type" => "heading");  

$options[] = array( "name" => "Enable Cufon font",
					"desc" => "Enable <a href=\"http://cufon.shoqolate.com/generate/\">Cufon</a> font replacement. Replaces Headers to <a href=\"http://www.fontsquirrel.com/fonts/Liberation-Sans\">Liberation Sans</a> font.",
					"id" => $shortname."_cufon",
					"std" => "true",
					"type" => "checkbox");    

$options[] = array( "name" => "Full Content Home",
					"desc" => "Show the full content in posts on homepage instead of the excerpt.",
					"id" => $shortname."_home_content",
					"std" => "false",
					"type" => "checkbox");    

$options[] = array( "name" => "Full Content Archive",
					"desc" => "Show the full content in posts on archive pages instead of the excerpt.",
					"id" => $shortname."_archive_content",
					"std" => "false",
					"type" => "checkbox");

$options[] = array( "name" =>  "Disable Post Author",
					"desc" => "Disable post author below post?",
					"id" => $shortname."_disable_post_author",
					"std" => "false",
					"type" => "checkbox"); 

$options[] = array( "name" => "Sales Page Options",
                    "icon" => "post",
					"type" => "heading");

$options[] = array( "name" => "Width For Page Template - \"Sales Page No Header No Footer\"",
					"desc" => "Enter Width - Default is 960px",
					"id" => $shortname."_sp_noheadfoot_width",
					"std" => "",
					"type" => "text");

$options[] = array( "name" => "Font Size",
					"desc" => "Enter size of font in pixels e.g. 14px",
					"id" => $shortname."_sp_noheadfoot_fontsize",
					"std" => "",
					"type" => "text");

$options[] = array( "name" =>  "Custom Background Color",
					"desc" => "Add a custom hex color for the background color, e.g. #697e09",
					"id" => $shortname."_sp_noheadfoot_bg",
					"std" => "",
					"type" => "color");

$options[] = array( "name" =>  "Custom Border Color",
					"desc" => "Add a custom hex color for the border, e.g. #697e09",
					"id" => $shortname."_sp_noheadfoot_border",
					"std" => "",
					"type" => "color");

$options[] = array( "name" => "Custom Border Size",
					"desc" => "Enter size - default is 1px",
					"id" => $shortname."_sp_noheadfoot_bordersize",
					"std" => "",
					"type" => "text");

$options[] = array( "name" => "Custom Border Style",
					"desc" => "Select style of border",
					"id" => $shortname."_sp_noheadfoot_borderstyle",
					"std" => "solid",
					"type" => "radio",
					"options" => $options_noheadfoot_bstyle);

$options[] = array( "name" => "Custom Border Radius",
					"desc" => "Enter radius size, for example 10 (do not add px)",
					"id" => $shortname."_sp_noheadfoot_borderradius",
					"std" => "",
					"type" => "text");

$options[] = array( "name" => "Add Padding Inside Page Area",
					"desc" => "Enter an integer value i.e. 20 for the image size. Max width is 576.",
					"id" => "",
					"std" => "",
					"type" => array( 
									array(  'id' => $shortname. '_padd_right',
											'type' => 'text',
											'std' => 50,
											'meta' => 'Right'),
									array(  'id' => $shortname. '_padd_left',
											'type' => 'text',
											'std' => 50,
											'meta' => 'Left'),
									array(  'id' => $shortname. '_padd_top',
											'type' => 'text',
											'std' => 20,
											'meta' => 'Top'),
									array(  'id' => $shortname. '_padd_bottom',
											'type' => 'text',
											'std' => 20,
											'meta' => 'Bottom')
								  ));

$options[] = array( "name" => "Show <u>Blog</u> Footer On <u>All</u> Sales Pages?",
					"desc" => "Tick the box if you want to show the main blog's footer",
					"id" => $shortname."_show_sp_footer",
					"std" => "false",
					"type" => "checkbox");

$options[] = array( "name" => "Show <u>Blog</u> Footer By Page IDs Only <span style='color:#e82f0b;font-size:12px;'> (Untick \"Show <u>Blog</u> Footer On <u>All</u> Sales Pages!\")</span>",
					"desc" => "Enter the Page IDs to show the footer",
					"id" => $shortname."_show_sp_footer_id",
					"std" => "",
					"type" => "text");

$options[] = array( "name" => "Show <u>Custom</u> Footer On Sales Pages? <span style='color:#e82f0b;font-size:12px;'> (Untick \"Show <u>Blog</u> Footer On <u>All</u> Sales Pages!\")</span>",
					"desc" => "Tick the box if you want to show custom footer links",
					"id" => $shortname."_show_custom_footer",
					"std" => "false",
					"class" => "collapsed",
					"type" => "checkbox");

$options[] = array( "name" => "Enter HTML Links Code below",
					"desc" => "Enter your HTML Links Code",
					"id" => $shortname."_show_custom_footer_code",
					"type" => "textarea",
					"class" => "hidden",
					"std" => 'Paste Your Links HTML Here. For example, <a href="#" title="About" target="_self">About</a> | <a href="#" title="Terms" target="_self">Terms &amp; Conditions</a> | <a href="#" title="FAQ" target="_self">FAQ</a> | <a href="#" title="Support" target="_self">Support</a>');

$options[] = array( "name" =>  "Custom Footer Font Color",
					"desc" => "Add a custom hex color for the left ribbon font color e.g. #697e09",
					"id" => $shortname."_custom_footer_font_color",
					"std" => "",					
					"class" => "hidden",
					"type" => "color");

$options[] = array( "name" =>  "Underline Custom Footer Links?",
					"desc" => "Choose whether or not to underline footer links",
					"id" => $shortname."_custom_footer_underline",
					"class" => "hidden",
					"std" => "true",
					"type" => "checkbox");

//Replace Affiliate Links
$options[] = array( "name" => "Replace Affiliate URLs",
                    "icon" => "ads2",
                    "type" => "heading");

$options[] = array( "name" => "<span style='padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;'>Replace Affiliate URLs - Instructions</span>",
        			"type" => "para",
					"desc" => "<span style='font-weight:bold; color:#e82f0b;'>Step 1)</span> - If using Clickbank, Click the Clickbank Hoplink Encoding URL below. It will open in a new window.<br /><br />
								<span style='font-weight:bold; color:#e82f0b;'>Step 2)</span> - On the Clickbank Hoplink Encoding webpage, add your Clickbank ID (aka Affiliate Nickname) and one of the Clickbank Vendor IDs below in Step 2.<br /><br />** Repeat Step 2 twice until you have BOTH your <strong>unique</strong> Affiliate URLs.<br /><br />
								<span style='font-weight:bold; color:#e82f0b;'>Steps 3 &amp; 4)</span> - Add Your Affiliate URLs (Clickbank, etc.), Title/Alt Tags, Banner URLs </strong>.<br /><br />
								<span style='font-weight:bold; color:#e82f0b;'>Step 5)</span> - Tick the box in <strong>Step 5</strong> to enable the 468px by 60px banner in the <strong>header area</strong>. Enter your Affiliate URL (Clickbank, etc.) that you created earlier that relates to the banner/product. You can replace the banner with Adsense if you prefer.<br /><br />
								<span style='font-weight:bold; color:#e82f0b;'>Step 6)</span> - Click the <strong>Save All Changes</strong> button at the bottom.<br /><br />
								<span style='font-weight:bold; color:#e82f0b;'>Step 7)</span> - Now go to your site and hover your mouse over each banner to make sure the correct Affiliate Links/Alt Tags/Banners are appearing!<br /><br /><br /><br />
								");

$options[] = array( "name" => "<span style='padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;'>Step 1 - Click The Link Below To Create Your Encoded Hoplinks</span> <br /><br /><a href='https://www.clickbank.com/hoplink_encoding.htm' target='_blank'>https://www.clickbank.com/hoplink_encoding.htm</a>",
					"id" => "",
					"std" => "");

$options[] = array( "name" => "<span style='padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;'>Step 2 - Clickbank Vendor IDs To Encode Your Hoplinks From The URL Above</span>",
					"desc" => "",
					"id" => "",
					"std" => "",
					"type" => array( 
									array(  'id' => $shortname.'_blank_1',
											'std' => 'vendor id 1',
											'meta' => 'Clickbank Vendor ID #1',
											'type' => 'text'),
									array(  'id' => $shortname.'_blank_2',
											'std' => 'vendor id 2',
											'meta' => 'Clickbank Vendor ID #2',
											'type' => 'text')
								));

$options[] = array( "name" => "<span style='padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;'>Step 3 - Add Your Affiliate URL #1 Below</span>",
					"desc" => "<span style='font-size:11px; font-weight:normal;'>This creates shortcode <strong>[aff1link]</strong></span>",
					"id" => $shortname."_aff1_link",
					"std" => "Put your Affiliate URL #1 here",
					"type" => "text");

$options[] = array( "name" => "<span style='color:#e82f0b; font-size:13px; font-weight:bold;'>Banner Title/Alt Tags For Affiliate URL #1</span>",
					"desc" => "<span style='font-size:11px; font-weight:normal;'>This creates shortcode <strong>[aff1tag]</strong></span>",
					"id" => $shortname."_aff1_title_tag",
					"std" => "Put your Title/Alt info here",
					"type" => "text");

$options[] = array( "name" => "<span style='color:#e82f0b; font-size:13px; font-weight:bold;'>Enter 300x250 Banner Link For Affiliate URL #1</span>",
					"desc" => "<span style='font-size:11px; font-weight:normal;'>This creates shortcode <strong>[aff1banner1]</strong></span>",
					"id" => $shortname."_aff1_banner_url_1",
					"std" => "Put your 300x250 Banner URL here",
					"type" => "upload");

$options[] = array( "name" => "<span style='color:#e82f0b; font-size:13px; font-weight:bold;'>Enter 125x125 Banner Link For Affiliate URL #1</span>",
					"desc" => "<span style='font-size:11px; font-weight:normal;'>This creates shortcode <strong>[aff1banner2]</strong></span>",
					"id" => $shortname."_aff1_banner_url_2",
					"std" => "Put your 125x125 Banner URL here",
					"type" => "upload");

$options[] = array( "name" => "<span style='color:#e82f0b; font-size:13px; font-weight:bold;'>Enter 468x60 Banner Link For Affiliate URL #1</span> (if applicable)",
					"desc" => "<span style='font-size:11px; font-weight:normal;'>This creates shortcode <strong>[aff1banner3]</strong></span>",
					"id" => $shortname."_aff1_banner_url_3",
					"std" => "Put your 468x60 Banner URL here",
					"type" => "upload");

$options[] = array( "name" => "<span style='padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;'>Step 4 - Add Your Affiliate URL #2 Below</span>",
					"desc" => "<span style='font-size:11px; font-weight:normal;'>This creates shortcode <strong>[aff2link]</span>",
					"id" => $shortname."_aff2_link",
					"std" => "Put your Affiliate URL #2 here",
					"type" => "text");

$options[] = array( "name" => "<span style='color:#e82f0b; font-size:13px; font-weight:bold;'>Banner Title/Alt Tags For Affiliate URL #2</span>",
					"desc" => "<span style='font-size:11px; font-weight:normal;'>This creates shortcode <strong>[aff2tag]</strong></span>",
					"id" => $shortname."_aff2_title_tag",
					"std" => "Put your Title/Alt info here",
					"type" => "text");

$options[] = array( "name" => "<span style='color:#e82f0b; font-size:13px; font-weight:bold;'>Enter 300x250 Banner Link For Affiliate URL #2</span>",
					"desc" => "<span style='font-size:11px; font-weight:normal;'>This creates shortcode <strong>[aff2banner1]</strong></span>",
					"id" => $shortname."_aff2_banner_url_1",
					"std" => "Put your 300x250 Banner URL here",
					"type" => "upload");

$options[] = array( "name" => "<span style='color:#e82f0b; font-size:13px; font-weight:bold;'>Enter 125x125 Banner Link For Affiliate URL #2</span>",
					"desc" => "<span style='font-size:11px; font-weight:normal;'>This creates shortcode <strong>[aff2banner2]</strong></span>",
					"id" => $shortname."_aff2_banner_url_2",
					"std" => "Put your 125x125 Banner URL here",
					"type" => "upload");

$options[] = array( "name" => "<span style='color:#e82f0b; font-size:13px; font-weight:bold;'>Enter 468x60 Banner Link For Affiliate URL #2</span> (if applicable)",
					"desc" => "<span style='font-size:11px; font-weight:normal;'>This creates shortcode <strong>[aff2banner3]</strong></span>",
					"id" => $shortname."_aff2_banner_url_3",
					"std" => "Put your 468x60 (on Video Page) Banner URL here",
					"type" => "upload");

$options[] = array( "name" => "<span style='padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;'>Step 5 - Enable 468x60 Header Banner</span>",
					"desc" => "Enable 468x60 banner ad space",
					"id" => $shortname."_ad_top",
					"std" => "true",
					"type" => "checkbox");    

$options[] = array( "name" => "<span style='color:#e82f0b; font-size:13px; font-weight:bold;'>Enter 468x60 Header Banner URL</span>",
					"desc" => "Enter the URL to the banner ad image location.",
					"id" => $shortname."_ad_top_image",
					"std" => "http://www.woothemes.com/ads/468x60b.jpg",
					"type" => "upload");

$options[] = array( "name" => "<span style='color:#e82f0b; font-size:13px; font-weight:bold;'>Enter 468x60 Header Banner Affiliate URL</span>",
					"desc" => "Enter the URL where this banner ad points to.",
					"id" => $shortname."_ad_top_url",
					"std" => "http://www.woothemes.com",
					"type" => "text");

$options[] = array( "name" => "Adsense code (optional) - if you prefer Adsense over an affiliate banner",
					"desc" => "Enter your adsense code (or other ad network code) here.",
					"id" => $shortname."_ad_top_adsense",
					"std" => "",
					"type" => "textarea");

//Footer Disclaimer
$options[] = array( "name" => "Footer Disclaimer",
                    "icon" => "post",
                    "type" => "heading");

$options[] = array( "name" => "Show Footer Disclaimer?",
					"desc" => "Tick the box if you want to show a disclaimer in the footer (recommended)",
					"id" => $shortname."_show_dislcaimer_footer",
					"std" => "true",
					"type" => "checkbox");

$options[] = array( "name" => "Type In Your Disclaimer Or Use The One Below",
					"desc" => "Type or Paste Disclaimer",
					"id" => $shortname."_custom_footer_disclaimer",
					"std" => "Disclaimer: This website is an officially authorized and remunerated associate for recommending high quality products found on this website. Links on this website may be associate links which means if you click on a link of a recommended product, I/we may receive monetary compensation. However, this does not affect any unbiased information presented on this website.",
					"type" => "textarea");

$options[] = array( "name" => "Disclaimer Font Size - Just Type The Number, Don't Add 'px'",
					"desc" => "Enter font size e.g. type 14 to mean 14px",
					"id" => $shortname."_disclaimer_fontsize",
					"std" => "",
					"type" => "text");

$options[] = array( "name" =>  "Custom Link Color",
					"desc" => "Add a custom hex color for the links in your site e.g. #697e09",
					"id" => "woo_disclaimer_color",
					"std" => "",
					"type" => "color");

//Link Seeker
$options[] = array( "name" => "Backlink Tips",
                    "icon" => "linkseeker",
                    "type" => "heading");

$options[] = array( "name" => "<span style='padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;'>Find .edu, .gov, and other URLs to \"drop your links\" - <u><i>Don't Spam!</i></u></span>",
        			"type" => "para",
					"desc" => "Click The Link Below To Search For Sites To Leave Well-Constructed Comments! <br /><br /><a href='http://dropmylink.com/' target='_blank'>Drop My Link</a><br /><br />
							   <span style='font-weight:bold; color:#e82f0b;'>Please Note:</span> While most links may be considered \"good\", don't fall for the <i>\".edu or .org links will skyrocket your site to the top of Google!\".</i> Mix up your backlink strategy for best results!<br /><br />
							   ** Consider these other options:<br /><br />
							   - Article directories like those listed below:<br /><br />
								<ol>
									<li><a href='http://www.ezinearticles.com' target='_blank'>EzineArticles.com</a></li>
									<li><a href='http://www.goarticles.com' target='_blank'>GoArticles.com</a></li>
									<li><a href='http://www.articlesbase.com' target='_blank'>ArticlesBase.com</a></li>
								</ol><br />
							   - Outsource link building, press releases etc. <br /><br />
								<ol>
									<li>Try the <a href='http://www.warriorforum.com/warriors-hire/' target='_blank'>Warrior's For Hire</a> section</li>
								</ol><br />
							   - And so on.<br /><br />
								");

$options[] = array( "name" => "Dynamic Images",
					"type" => "heading",
					"icon" => "image");    
				    				   
$options[] = array( "name" => "Enable WordPress Post Thumbnail Support",
					"desc" => "Use WordPress post thumbnail support to assign a post thumbnail.",
					"id" => $shortname."_post_image_support",
					"std" => "true",
					"class" => "collapsed",
					"type" => "checkbox"); 

$options[] = array( "name" => "Dynamically Resize Post Thumbnail",
					"desc" => "The post thumbnail will be dynamically resized using native WP resize functionality. <em>(Requires PHP 5.2+)</em>",
					"id" => $shortname."_pis_resize",
					"std" => "true",
					"class" => "hidden",
					"type" => "checkbox"); 									   
					
$options[] = array( "name" => "Hard Crop Post Thumbnail",
					"desc" => "The image will be cropped to match the target aspect ratio.",
					"id" => $shortname."_pis_hard_crop",
					"std" => "true",
					"class" => "hidden last",
					"type" => "checkbox"); 									   

$options[] = array( "name" => "Enable Dynamic Image Resizer",
					"desc" => "This will enable the thumb.php script which dynamically resizes images on your site.",
					"id" => $shortname."_resize",
					"std" => "true",
					"type" => "checkbox");    
                    
$options[] = array( "name" => "Automatic Image Thumbs",
					"desc" => "If no image is specified in the 'image' custom field then the first uploaded post image is used.",
					"id" => $shortname."_auto_img",
					"std" => "false",
					"type" => "checkbox");  

$options[] = array( "name" => "Show Image in RSS feed",
					"desc" => "Will show the image uploaded to 'image' custom field in the RSS feed.",
					"id" => $shortname."_rss_thumb",
					"std" => "false",
					"type" => "checkbox");    

$options[] = array( "name" => "Image alignment",
					"desc" => "Select how to align your images with posts (front page and archives).",
					"id" => $shortname."_align",
					"std" => "alignleft",
					"type" => "radio",
					"options" => $options_radio); 

$options[] = array( "name" => "Image Dimensions",
					"desc" => "Enter an integer value i.e. 250 for the image size. Max width is 576.",
					"id" => $shortname."_image_dimensions",
					"std" => "",
					"type" => array( 
									array(  'id' => $shortname. '_thumb_width',
											'type' => 'text',
											'std' => 200,
											'meta' => 'Width'),
									array(  'id' => $shortname. '_thumb_height',
											'type' => 'text',
											'std' => 200,
											'meta' => 'Height')
								  ));
                                                                                                
$options[] = array( "name" => "Show in Single Posts",
					"desc" => "Show the attached image in the single post page. <strong>Note:</strong> You must disable content ad.",
					"id" => $shortname."_image_single",
					"std" => "false",
					"type" => "checkbox");    

$options[] = array( "name" => "Single Image Dimensions",
					"desc" => "Enter an integer value i.e. 250 for the image size. Max width is 576.",
					"id" => $shortname."_image_dimensions",
					"std" => "",
					"type" => array( 
									array(  'id' => $shortname. '_single_width',
											'type' => 'text',
											'std' => 200,
											'meta' => 'Width'),
									array(  'id' => $shortname. '_single_height',
											'type' => 'text',
											'std' => 200,
											'meta' => 'Height')
								  ));     

$options[] = array( "name" => "Content Ad (200x200px)",
                    "icon" => "ads",
					"type" => "heading");

$options[] = array( "name" => "Enable Ad",
					"desc" => "Enable the ad space",
					"id" => $shortname."_ad_content",
					"std" => "false",
					"type" => "checkbox");    

$options[] = array( "name" => "Adsense code",
					"desc" => "Enter your adsense code (or other ad network code) here.",
					"id" => $shortname."_ad_content_adsense",
					"std" => "",
					"type" => "textarea");

$options[] = array( "name" => "Image Location",
					"desc" => "Enter the URL for this banner ad.",
					"id" => $shortname."_ad_content_image",
					"std" => "Enter Image URL",
					"type" => "upload");

$options[] = array( "name" => "Destination URL",
					"desc" => "Enter the URL where this banner ad points to.",
					"id" => $shortname."_ad_content_url",
					"std" => "http://www.woothemes.com",
					"type" => "text");                        

$options[] = array(	"name" => "Widget Ads (125x125)",
                    "icon" => "ads",
					"type" => "heading");

$options[] = array(	"name" => "Rotate banners?",
					"desc" => "Check this to randomly rotate the banner ads.",
					"id" => $shortname."_ads_rotate",
					"std" => "true",
					"type" => "checkbox");	

$options[] = array(	"name" => "Banner Ad #1 - Image Location",
					"desc" => "Enter the URL for this banner ad.",
					"id" => $shortname."_ad_image_1",
					"std" => "http://www.woothemes.com/ads/125x125b.jpg",
					"type" => "text");
						
$options[] = array(	"name" => "Banner Ad #1 - Destination",
					"desc" => "Enter the URL where this banner ad points to.",
					"id" => $shortname."_ad_url_1",
					"std" => "http://www.woothemes.com",
					"type" => "text");						

$options[] = array(	"name" => "Banner Ad #2 - Image Location",
					"desc" => "Enter the URL for this banner ad.",
					"id" => $shortname."_ad_image_2",
					"std" => "http://www.woothemes.com/ads/125x125b.jpg",
					"type" => "text");
						
$options[] = array(	"name" => "Banner Ad #2 - Destination",
					"desc" => "Enter the URL where this banner ad points to.",
					"id" => $shortname."_ad_url_2",
					"std" => "http://www.woothemes.com",
					"type" => "text");

$options[] = array(	"name" => "Banner Ad #3 - Image Location",
					"desc" => "Enter the URL for this banner ad.",
					"id" => $shortname."_ad_image_3",
					"std" => "http://www.woothemes.com/ads/125x125b.jpg",
					"type" => "text");
						
$options[] = array(	"name" => "Banner Ad #3 - Destination",
					"desc" => "Enter the URL where this banner ad points to.",
					"id" => $shortname."_ad_url_3",
					"std" => "http://www.woothemes.com",
					"type" => "text");

$options[] = array(	"name" => "Banner Ad #4 - Image Location",
					"desc" => "Enter the URL for this banner ad.",
					"id" => $shortname."_ad_image_4",
					"std" => "http://www.woothemes.com/ads/125x125b.jpg",
					"type" => "text");
						
$options[] = array(	"name" => "Banner Ad #4 - Destination",
					"desc" => "Enter the URL where this banner ad points to.",
					"id" => $shortname."_ad_url_4",
					"std" => "http://www.woothemes.com",
					"type" => "text");

$options[] = array(	"name" => "Banner Ad #5 - Image Location",
					"desc" => "Enter the URL for this banner ad.",
					"id" => $shortname."_ad_image_5",
					"std" => "http://www.woothemes.com/ads/125x125b.jpg",
					"type" => "text");
						
$options[] = array(	"name" => "Banner Ad #5 - Destination",
					"desc" => "Enter the URL where this banner ad points to.",
					"id" => $shortname."_ad_url_5",
					"std" => "http://www.woothemes.com",
					"type" => "text");

$options[] = array(	"name" => "Banner Ad #6 - Image Location",
					"desc" => "Enter the URL for this banner ad.",
					"id" => $shortname."_ad_image_6",
					"std" => "http://www.woothemes.com/ads/125x125b.jpg",
					"type" => "text");
						
$options[] = array(	"name" => "Banner Ad #6 - Destination",
					"desc" => "Enter the URL where this banner ad points to.",
					"id" => $shortname."_ad_url_6",
					"std" => "http://www.woothemes.com",
					"type" => "text");

// Add extra options through function
if ( function_exists("woo_options_add") )
	$options = woo_options_add($options);

if ( get_option('woo_template') != $options) update_option('woo_template',$options);      
if ( get_option('woo_themename') != $themename) update_option('woo_themename',$themename);   
if ( get_option('woo_shortname') != $shortname) update_option('woo_shortname',$shortname);
if ( get_option('woo_manual') != $manualurl) update_option('woo_manual',$manualurl);

                                     
// Woo Metabox Options
                    

$woo_metaboxes = array(

        "image" => array (
            "name"  => "image",
            "std"  => "",
            "label" => "Custom Thumbnail Image",
            "type" => "upload",
            "desc" => "Upload an image to show with your post."
        ),
        "embed" => array (
            "name"  => "embed",
            "std"  => "",
            "label" => "Embed Code",
            "type" => "textarea",
            "desc" => "Enter the video embed code for your video (YouTube, Vimeo or similar)"
        )
    );
    
// Add extra metaboxes through function
if ( function_exists("woo_metaboxes_add") )
	$woo_metaboxes = woo_metaboxes_add($woo_metaboxes);
    
if ( get_option('woo_custom_template') != $woo_metaboxes) update_option('woo_custom_template',$woo_metaboxes);    

}
}

function welcome_intro_function(){
     ?>
<h3><span style="color:#ff7f00; font-weight:bold; font-size:18px;">Getting Started</span></h3>
<br />
<ol style="font-size:14px;">
<li>Please go to <a href="<?php bloginfo('url'); ?>/wp-admin/users.php"><u><strong>Users</strong></u></a> in the menu below to the left, and <strong>change your Password</strong> as soon as possible.</li><br />
<li>While in <a href="<?php bloginfo('url'); ?>/wp-admin/users.php"><u><strong>Users</strong></u></a>, <strong>change your email address</strong>.</li><br />
<li>Next, <strong>change your email address</strong> in both <a href="<?php bloginfo('url'); ?>/wp-admin/options-general.php"><u><strong>Settings</strong></u></a> and <a href="<?php bloginfo('url'); ?>/wp-admin/admin.php?page=wpcf7"><u><strong>Contact</strong></u></a>. Again, please refer to the <strong>setup videos</strong> if necessary.</li><br />
<li>If you haven't already, please watch the video on adding your custom clickbank affiliate links. Then, go to <a href="<?php bloginfo('url'); ?>/wp-admin/admin.php?page=woothemes"><u><strong>Headlines Enhanced >> Theme Options</strong></u></a> and click the <strong>Replace Affiliate URLs tab</strong> to create and add your affiliate links.</li><br />
<li>It is highly recommended that you watch <strong>ALL</strong> the videos showing you how to set up your blog.</li><br />
<li>Be sure to make each article as <strong>unique</strong> as possible for best results in the search engines!</li><br />
<li>Stay focused and have fun!</li>
</ol>

<?php }

function admin_welcome_widgets(){
     wp_add_dashboard_widget( 'welcome_intro_widget', 'Congratulations on installing this blog!', 'welcome_intro_function');
} 

add_action('wp_dashboard_setup', 'admin_welcome_widgets' );

?>